Bug 1032640 - org.apache.camel.Exchange not found in Milyn module [NEEDINFO]
org.apache.camel.Exchange not found in Milyn module
Status: MODIFIED
Product: JBoss Fuse Service Works 6
Classification: JBoss
Component: SwitchYard (Show other bugs)
6.0.0
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Tomohisa Igarashi
Matej Melko
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-20 09:11 EST by Jochen Cordes
Modified: 2015-11-02 03:04 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
org.apache.camel.Exchange is missing from Milyn. This causes errors when Smooks is used. To work around this, add the following dependency to JBOSS_HOME/modules/system/layers/soa/org/milyn/main/module.xml: <programlisting> <![CDATA[ <module name="org.apache.camel.core" /> ]]> </programlisting>
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
kconner: needinfo? (jcordes)


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker SWITCHYARD-2211 Major Resolved Smooks Transformer not usable anymore cause of ClassNotFound error 2016-11-18 11:39 EST
JBoss Issue Tracker SWITCHYARD-2307 Major Closed org.apache.camel.Exchange not found in Milyn module 2016-11-18 11:39 EST

  None (edit)
Description Jochen Cordes 2013-11-20 09:11:19 EST
Description of problem:

When using Smooks, there is an issue with Milyn as org.apache.camel.Exchange is not found:

13:46:22,257 INFO  [org.switchyard.common.camel.SwitchYardCamelContext] (MSC service thread 1-3) Apache Camel 1.1.0.M3-redhat-2 (CamelContext: camel-1) is starting
13:46:22,362 WARN  [org.apache.camel.impl.converter.AnnotationTypeConverterLoader] (MSC service thread 1-3) Ignoring converter type: org.milyn.smooks.camel.converters.ResultConverter as a dependent class could not be found: java.lang.NoClassDefFoundError: org/apache/camel/Exchange: java.lang.NoClassDefFoundError: org/apache/camel/Exchange
       at java.lang.Class.getDeclaredMethods0(Native Method) [rt.jar:1.7.0_45]
       at java.lang.Class.privateGetDeclaredMethods(Class.java:2531) [rt.jar:1.7.0_45]
       at java.lang.Class.getDeclaredMethods(Class.java:1855) [rt.jar:1.7.0_45]
       at org.apache.camel.impl.converter.AnnotationTypeConverterLoader.loadConverterMethods(AnnotationTypeConverterLoader.java:260) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.converter.AnnotationTypeConverterLoader.load(AnnotationTypeConverterLoader.java:128) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.converter.BaseTypeConverterRegistry.loadTypeConverters(BaseTypeConverterRegistry.java:489) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.converter.DefaultTypeConverter.doStart(DefaultTypeConverter.java:42) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.support.ServiceSupport.start(ServiceSupport.java:60) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.startService(DefaultCamelContext.java:1777) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.doAddService(DefaultCamelContext.java:940) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.addService(DefaultCamelContext.java:901) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.getTypeConverter(DefaultCamelContext.java:1064) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.getTypeConverterRegistry(DefaultCamelContext.java:1081) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.forceLazyInitialization(DefaultCamelContext.java:2129) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.doStartCamel(DefaultCamelContext.java:1548) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.doStart(DefaultCamelContext.java:1453) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.support.ServiceSupport.start(ServiceSupport.java:60) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.apache.camel.impl.DefaultCamelContext.start(DefaultCamelContext.java:1421) [camel-core-2.10.0.redhat-60024.jar:2.10.0.redhat-60024]
       at org.switchyard.common.camel.SwitchYardCamelContext.start(SwitchYardCamelContext.java:181) [switchyard-common-camel-1.1.0.M3-redhat-2.jar:1.1.0.M3-redhat-2]
       at org.switchyard.bus.camel.CamelExchangeBus.start(CamelExchangeBus.java:71) [switchyard-bus-camel-1.1.0.M3-redhat-2.jar:1.1.0.M3-redhat-2]
       at org.switchyard.internal.DomainImpl.init(DomainImpl.java:219) [switchyard-runtime-1.1.0.M3-redhat-2.jar:1.1.0.M3-redhat-2]
       at org.switchyard.deploy.ServiceDomainManager.createDomain(ServiceDomainManager.java:117) [switchyard-deploy-1.1.0.M3-redhat-2.jar:1.1.0.M3-redhat-2]
       at org.switchyard.as7.extension.deployment.SwitchYardDeployment.start(SwitchYardDeployment.java:95) [switchyard-deploy-jboss-as7-1.1.0.M3-redhat-2.jar:1.1.0.M3-redhat-2]
       at org.switchyard.as7.extension.services.SwitchYardService.start(SwitchYardService.java:73) [switchyard-deploy-jboss-as7-1.1.0.M3-redhat-2.jar:1.1.0.M3-redhat-2]
       at org.jboss.msc.service.ServiceControllerImpl$StartTask.startService(ServiceControllerImpl.java:1811) [jboss-msc-1.0.4.GA-redhat-1.jar:1.0.4.GA-redhat-1]
       at org.jboss.msc.service.ServiceControllerImpl$StartTask.run(ServiceControllerImpl.java:1746) [jboss-msc-1.0.4.GA-redhat-1.jar:1.0.4.GA-redhat-1]
       at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1145) [rt.jar:1.7.0_45]
       at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:615) [rt.jar:1.7.0_45]
       at java.lang.Thread.run(Thread.java:744) [rt.jar:1.7.0_45]

Caused by: java.lang.ClassNotFoundException: org.apache.camel.Exchange from [Module "org.milyn:main" from local module loader @6ea0fbf0 (finder: local module finder @afc824e (roots: D:\dev\schub\jboss-eap-6.1\modules,D:\dev\schub\jboss-eap-6.1\modules\system\layers\soa,D:\dev\schub\jboss-eap-6.1\modules\system\layers\base))]
       at org.jboss.modules.ModuleClassLoader.findClass(ModuleClassLoader.java:196) [jboss-modules.jar:1.2.0.Final-redhat-1]
       at org.jboss.modules.ConcurrentClassLoader.performLoadClassUnchecked(ConcurrentClassLoader.java:444) [jboss-modules.jar:1.2.0.Final-redhat-1]
       at org.jboss.modules.ConcurrentClassLoader.performLoadClassChecked(ConcurrentClassLoader.java:432) [jboss-modules.jar:1.2.0.Final-redhat-1]
       at org.jboss.modules.ConcurrentClassLoader.performLoadClass(ConcurrentClassLoader.java:374) [jboss-modules.jar:1.2.0.Final-redhat-1]
       at org.jboss.modules.ConcurrentClassLoader.loadClass(ConcurrentClassLoader.java:119) [jboss-modules.jar:1.2.0.Final-redhat-1]
       ... 29 more

Version-Release number of selected component (if applicable):

6.0.0 Beta

How reproducible:

Always

Steps to Reproduce:

1. Add a Smooks converter
2. Restart the instance
3.

Actual results:

Converter does work

Expected results:

Converter does not work

Additional info:

Workaround:

Add the following dependency to JBOSS_HOME/modules/system/layers/soa/org/milyn/main/module.xml

<module name="org.apache.camel.core" />
Comment 2 Keith Babo 2013-11-20 11:02:29 EST
Using smooks transformer in SwitchYard or invoking Smooks from a camel route directly?  Please attach an app we can use to reproduce.
Comment 3 Keith Babo 2015-01-28 07:34:10 EST
Still looking for a reproducer, but I suspect this has to do with using Smooks directly from Camel vs. using Smooks in a declarative transformation.
Comment 4 Tomohisa Igarashi 2015-01-28 08:03:21 EST
org.apache.camel.core dependency has been added to smooks module recently due to SWITCHYARD-2211, it hit another error though. I created a reproducer for SWITCHYARD-2211 which invokes smooks from camel route, and verified it works with the fix. Please note Smooks itself needs to be updated to 1.5.2 in the ip-bom as well. See SWITCHYARD-2211 for more detail.
Comment 5 JBoss JIRA Server 2015-01-28 08:06:49 EST
Tomohisa igarashi <tm.igarashi@gmail.com> updated the status of jira SWITCHYARD-2307 to Closed

Note You need to log in before you can comment on or make changes to this bug.